<template>
  <div :class="[
    'calendar-cell', isCellWorking, {
        'today-cell' : isToday(cellNumber)}
      ]"
       @click="changeWorkingDay(cellNumber)">
    {{ cellNumber }}
    <div class="time-of-work">
      {{ getTimeOfWork }}
    </div>
  </div>
</template>

<script>
import moment from 'moment';

export default {
  name: 'DateCell',

  props: {
    startingDate: {
      type: String,
      default: '',
    },
    alteredCells: {
      type: Object,
      default: () => {},
    },
    cellNumber: {
      type: Number,
      default: 0,
    },
    date: {
      type: String,
      default: '',
    },
    isWorking: {
      type: Boolean,
      default: false,
    },
  },

  computed: {
    getTimeOfWork() {
      return this.alteredCells[this.getAmountOfDays(this.cellNumber)]?.time || '';
    },

    isCellWorking() {
      if (Object.keys(this.alteredCells)
        .findIndex((el) => Number(el) === this.getAmountOfDays(this.cellNumber)) !== -1) {
        return this.alteredCells[this.getAmountOfDays(this.cellNumber)].state;
      }
      if (!this.isWorking) {
        return 'working-cell';
      } if (this.isWorking) {
        return 'not-working-cell';
      }
      return this.isWorking || 'wrongDate';
    },
  },

  methods: {
    changeWorkingDay(cellNumber) {
      this.$emit('changeWorkingDay', cellNumber);
    },

    getAmountOfDays(day) {
      const date = `${moment(this.date).format('YYYY-MM')}-${day}`;
      return moment(date, 'YYYY-MM-DD').diff(this.startingDate, 'days') + 1;
    },

    isToday(day) {
      if (moment().format('YYYY-MM') === this.date) {
        return String(day) === moment().format('D');
      }
      return false;
    },
  },
};
</script>
